﻿using System;

using Microsoft.Extensions.Logging;

namespace Obvs.Logging.NetCore
{
    public class NetCoreLogger : Obvs.Logging.ILogger
    {
        private readonly Microsoft.Extensions.Logging.ILogger _logger;

        public NetCoreLogger(Microsoft.Extensions.Logging.ILogger logger)
        {
            _logger = logger;
        }

        public void Debug(string message, Exception exception = null)
        {
            _logger.LogDebug(exception, message);
        }

        public void Info(string message, Exception exception = null)
        {
            _logger.LogInformation(exception, message);
        }

        public void Warn(string message, Exception exception = null)
        {
            _logger.LogWarning(exception, message);
        }

        public void Error(string message, Exception exception = null)
        {
            _logger.LogError(exception, message);
        }

        public void Log(LogLevel level, string message, Exception exception = null)
        {
            switch( level )
            {
                case LogLevel.Debug:
                    _logger.LogDebug(exception, message);
                    break;
                case LogLevel.Info:
                    _logger.LogInformation(exception, message);
                    break;
                case LogLevel.Warn:
                    _logger.LogWarning(exception, message);
                    break;
                case LogLevel.Error:
                    _logger.LogError(exception, message);
                    break;
            }
        }
    }
}
